Skip to main content
PUT
/
monitors
/
templates
/
{templateId}
Update a monitor template
curl --request PUT \
  --url https://api.eu.bronto.io/monitors/templates/{templateId} \
  --header 'Content-Type: application/json' \
  --header 'X-BRONTO-API-KEY: <api-key>' \
  --data @- <<EOF
{
  "name": "High Error Rate",
  "comparison_operator": "ABOVE",
  "threshold": 1000,
  "window": "'Last 20 minutes', 'Last 2 hours', 'Last 3 days'",
  "metric": {
    "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
    "arguments": {}
  },
  "description": "Average response time is over 1 seconds in the last 20 minutes",
  "warning_threshold": 1000,
  "no_data_status": "OK",
  "group_retention": 600000,
  "aux": {},
  "type": "PATTERN",
  "compare_to": "'2 hours ago', '1 days ago'",
  "this_template_tags": [
    {
      "name": "parser",
      "value": "apache_web_access_log"
    }
  ],
  "parameters": {}
}
EOF
import requests

url = "https://api.eu.bronto.io/monitors/templates/{templateId}"

payload = {
"name": "High Error Rate",
"comparison_operator": "ABOVE",
"threshold": 1000,
"window": "'Last 20 minutes', 'Last 2 hours', 'Last 3 days'",
"metric": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"arguments": {}
},
"description": "Average response time is over 1 seconds in the last 20 minutes",
"warning_threshold": 1000,
"no_data_status": "OK",
"group_retention": 600000,
"aux": {},
"type": "PATTERN",
"compare_to": "'2 hours ago', '1 days ago'",
"this_template_tags": [
{
"name": "parser",
"value": "apache_web_access_log"
}
],
"parameters": {}
}
headers = {
"X-BRONTO-API-KEY": "<api-key>",
"Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'PUT',
headers: {'X-BRONTO-API-KEY': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: 'High Error Rate',
comparison_operator: 'ABOVE',
threshold: 1000,
window: '\'Last 20 minutes\', \'Last 2 hours\', \'Last 3 days\'',
metric: {id: '3c90c3cc-0d44-4b50-8888-8dd25736052a', arguments: {}},
description: 'Average response time is over 1 seconds in the last 20 minutes',
warning_threshold: 1000,
no_data_status: 'OK',
group_retention: 600000,
aux: {},
type: 'PATTERN',
compare_to: '\'2 hours ago\', \'1 days ago\'',
this_template_tags: [{name: 'parser', value: 'apache_web_access_log'}],
parameters: {}
})
};

fetch('https://api.eu.bronto.io/monitors/templates/{templateId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "name": "High Error Rate",
  "comparison_operator": "ABOVE",
  "threshold": "1000",
  "window": "'Last 20 minutes', 'Last 2 hours', 'Last 1 days'",
  "type": "PATTERN",
  "metadata": {
    "created_at": 123,
    "created_by": {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
    },
    "modified_at": 123,
    "modified_by": {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
    },
    "deleted_at": 123,
    "deleted_by": {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
    },
    "last_heartbeat_at": 123
  },
  "description": "Average response time is over 1 seconds in the last 20 minutes",
  "warning_threshold": "900",
  "actions": "<string>",
  "notify_once": "false",
  "no_data_status": "OK",
  "group_retention": 600000,
  "aux": {},
  "compare_to": "2 hours ago",
  "metric_id": {
    "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
    "arguments": {}
  },
  "parameters": {}
}
{
"bad_request_validation": {
"summary": "Bad Request - Validation Error",
"description": "Example error when request validation fails",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "95c6a974e3ab01209b6b0dfedb1b16c5",
"details": "Validation failed: 'name' field is required and cannot be empty"
}
},
"bad_request_invalid_type": {
"summary": "Bad Request - Invalid Metric Type",
"description": "Example error when an invalid metric type is provided",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "00d8a51bb2874f2583670317a4fb8db7",
"details": "Invalid metric_type 'INVALID'. Must be one of: COUNTER, GAUGE, HISTOGRAM"
}
},
"forbidden": {
"summary": "Forbidden Access",
"description": "Example error when user lacks required permissions",
"value": {
"code": 403,
"type": "Forbidden",
"correlation_id": "40276639de0f49d586e32edd8c4f6b34",
"details": "Access denied. User does not have permission to create metric definition templates"
}
},
"not_found": {
"summary": "Resource Not Found",
"description": "Example error when requested resource doesn't exist",
"value": {
"code": 404,
"type": "Not Found",
"correlation_id": "605f832bcfe44a1081441691c8d42253",
"details": "Metric definition template with id '550e8400-e29b-41d4-a716-446655440000' not found"
}
},
"rate_limit": {
"summary": "Rate Limit Exceeded",
"description": "Example error when API rate limit is exceeded",
"value": {
"code": 429,
"type": "Too Many Requests",
"correlation_id": "53909ed43c544531b7a555e295960437",
"details": "Rate limit exceeded. Maximum 100 requests are allowed within a 5-minute window"
}
},
"internal_server_error": {
"summary": "Internal Server Error",
"description": "Example error for unexpected server-side failures",
"value": {
"code": 500,
"type": "Internal Server Error",
"correlation_id": "b129b8e0e66c41aa9541a30f67e38ce2",
"details": "An unexpected error occurred while processing your request"
}
}
}
{
"bad_request_validation": {
"summary": "Bad Request - Validation Error",
"description": "Example error when request validation fails",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "95c6a974e3ab01209b6b0dfedb1b16c5",
"details": "Validation failed: 'name' field is required and cannot be empty"
}
},
"bad_request_invalid_type": {
"summary": "Bad Request - Invalid Metric Type",
"description": "Example error when an invalid metric type is provided",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "00d8a51bb2874f2583670317a4fb8db7",
"details": "Invalid metric_type 'INVALID'. Must be one of: COUNTER, GAUGE, HISTOGRAM"
}
},
"forbidden": {
"summary": "Forbidden Access",
"description": "Example error when user lacks required permissions",
"value": {
"code": 403,
"type": "Forbidden",
"correlation_id": "40276639de0f49d586e32edd8c4f6b34",
"details": "Access denied. User does not have permission to create metric definition templates"
}
},
"not_found": {
"summary": "Resource Not Found",
"description": "Example error when requested resource doesn't exist",
"value": {
"code": 404,
"type": "Not Found",
"correlation_id": "605f832bcfe44a1081441691c8d42253",
"details": "Metric definition template with id '550e8400-e29b-41d4-a716-446655440000' not found"
}
},
"rate_limit": {
"summary": "Rate Limit Exceeded",
"description": "Example error when API rate limit is exceeded",
"value": {
"code": 429,
"type": "Too Many Requests",
"correlation_id": "53909ed43c544531b7a555e295960437",
"details": "Rate limit exceeded. Maximum 100 requests are allowed within a 5-minute window"
}
},
"internal_server_error": {
"summary": "Internal Server Error",
"description": "Example error for unexpected server-side failures",
"value": {
"code": 500,
"type": "Internal Server Error",
"correlation_id": "b129b8e0e66c41aa9541a30f67e38ce2",
"details": "An unexpected error occurred while processing your request"
}
}
}
{
"bad_request_validation": {
"summary": "Bad Request - Validation Error",
"description": "Example error when request validation fails",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "95c6a974e3ab01209b6b0dfedb1b16c5",
"details": "Validation failed: 'name' field is required and cannot be empty"
}
},
"bad_request_invalid_type": {
"summary": "Bad Request - Invalid Metric Type",
"description": "Example error when an invalid metric type is provided",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "00d8a51bb2874f2583670317a4fb8db7",
"details": "Invalid metric_type 'INVALID'. Must be one of: COUNTER, GAUGE, HISTOGRAM"
}
},
"forbidden": {
"summary": "Forbidden Access",
"description": "Example error when user lacks required permissions",
"value": {
"code": 403,
"type": "Forbidden",
"correlation_id": "40276639de0f49d586e32edd8c4f6b34",
"details": "Access denied. User does not have permission to create metric definition templates"
}
},
"not_found": {
"summary": "Resource Not Found",
"description": "Example error when requested resource doesn't exist",
"value": {
"code": 404,
"type": "Not Found",
"correlation_id": "605f832bcfe44a1081441691c8d42253",
"details": "Metric definition template with id '550e8400-e29b-41d4-a716-446655440000' not found"
}
},
"rate_limit": {
"summary": "Rate Limit Exceeded",
"description": "Example error when API rate limit is exceeded",
"value": {
"code": 429,
"type": "Too Many Requests",
"correlation_id": "53909ed43c544531b7a555e295960437",
"details": "Rate limit exceeded. Maximum 100 requests are allowed within a 5-minute window"
}
},
"internal_server_error": {
"summary": "Internal Server Error",
"description": "Example error for unexpected server-side failures",
"value": {
"code": 500,
"type": "Internal Server Error",
"correlation_id": "b129b8e0e66c41aa9541a30f67e38ce2",
"details": "An unexpected error occurred while processing your request"
}
}
}
{
"bad_request_validation": {
"summary": "Bad Request - Validation Error",
"description": "Example error when request validation fails",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "95c6a974e3ab01209b6b0dfedb1b16c5",
"details": "Validation failed: 'name' field is required and cannot be empty"
}
},
"bad_request_invalid_type": {
"summary": "Bad Request - Invalid Metric Type",
"description": "Example error when an invalid metric type is provided",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "00d8a51bb2874f2583670317a4fb8db7",
"details": "Invalid metric_type 'INVALID'. Must be one of: COUNTER, GAUGE, HISTOGRAM"
}
},
"forbidden": {
"summary": "Forbidden Access",
"description": "Example error when user lacks required permissions",
"value": {
"code": 403,
"type": "Forbidden",
"correlation_id": "40276639de0f49d586e32edd8c4f6b34",
"details": "Access denied. User does not have permission to create metric definition templates"
}
},
"not_found": {
"summary": "Resource Not Found",
"description": "Example error when requested resource doesn't exist",
"value": {
"code": 404,
"type": "Not Found",
"correlation_id": "605f832bcfe44a1081441691c8d42253",
"details": "Metric definition template with id '550e8400-e29b-41d4-a716-446655440000' not found"
}
},
"rate_limit": {
"summary": "Rate Limit Exceeded",
"description": "Example error when API rate limit is exceeded",
"value": {
"code": 429,
"type": "Too Many Requests",
"correlation_id": "53909ed43c544531b7a555e295960437",
"details": "Rate limit exceeded. Maximum 100 requests are allowed within a 5-minute window"
}
},
"internal_server_error": {
"summary": "Internal Server Error",
"description": "Example error for unexpected server-side failures",
"value": {
"code": 500,
"type": "Internal Server Error",
"correlation_id": "b129b8e0e66c41aa9541a30f67e38ce2",
"details": "An unexpected error occurred while processing your request"
}
}
}
{
"bad_request_validation": {
"summary": "Bad Request - Validation Error",
"description": "Example error when request validation fails",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "95c6a974e3ab01209b6b0dfedb1b16c5",
"details": "Validation failed: 'name' field is required and cannot be empty"
}
},
"bad_request_invalid_type": {
"summary": "Bad Request - Invalid Metric Type",
"description": "Example error when an invalid metric type is provided",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "00d8a51bb2874f2583670317a4fb8db7",
"details": "Invalid metric_type 'INVALID'. Must be one of: COUNTER, GAUGE, HISTOGRAM"
}
},
"forbidden": {
"summary": "Forbidden Access",
"description": "Example error when user lacks required permissions",
"value": {
"code": 403,
"type": "Forbidden",
"correlation_id": "40276639de0f49d586e32edd8c4f6b34",
"details": "Access denied. User does not have permission to create metric definition templates"
}
},
"not_found": {
"summary": "Resource Not Found",
"description": "Example error when requested resource doesn't exist",
"value": {
"code": 404,
"type": "Not Found",
"correlation_id": "605f832bcfe44a1081441691c8d42253",
"details": "Metric definition template with id '550e8400-e29b-41d4-a716-446655440000' not found"
}
},
"rate_limit": {
"summary": "Rate Limit Exceeded",
"description": "Example error when API rate limit is exceeded",
"value": {
"code": 429,
"type": "Too Many Requests",
"correlation_id": "53909ed43c544531b7a555e295960437",
"details": "Rate limit exceeded. Maximum 100 requests are allowed within a 5-minute window"
}
},
"internal_server_error": {
"summary": "Internal Server Error",
"description": "Example error for unexpected server-side failures",
"value": {
"code": 500,
"type": "Internal Server Error",
"correlation_id": "b129b8e0e66c41aa9541a30f67e38ce2",
"details": "An unexpected error occurred while processing your request"
}
}
}
{
"bad_request_validation": {
"summary": "Bad Request - Validation Error",
"description": "Example error when request validation fails",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "95c6a974e3ab01209b6b0dfedb1b16c5",
"details": "Validation failed: 'name' field is required and cannot be empty"
}
},
"bad_request_invalid_type": {
"summary": "Bad Request - Invalid Metric Type",
"description": "Example error when an invalid metric type is provided",
"value": {
"code": 400,
"type": "Bad Request",
"correlation_id": "00d8a51bb2874f2583670317a4fb8db7",
"details": "Invalid metric_type 'INVALID'. Must be one of: COUNTER, GAUGE, HISTOGRAM"
}
},
"forbidden": {
"summary": "Forbidden Access",
"description": "Example error when user lacks required permissions",
"value": {
"code": 403,
"type": "Forbidden",
"correlation_id": "40276639de0f49d586e32edd8c4f6b34",
"details": "Access denied. User does not have permission to create metric definition templates"
}
},
"not_found": {
"summary": "Resource Not Found",
"description": "Example error when requested resource doesn't exist",
"value": {
"code": 404,
"type": "Not Found",
"correlation_id": "605f832bcfe44a1081441691c8d42253",
"details": "Metric definition template with id '550e8400-e29b-41d4-a716-446655440000' not found"
}
},
"rate_limit": {
"summary": "Rate Limit Exceeded",
"description": "Example error when API rate limit is exceeded",
"value": {
"code": 429,
"type": "Too Many Requests",
"correlation_id": "53909ed43c544531b7a555e295960437",
"details": "Rate limit exceeded. Maximum 100 requests are allowed within a 5-minute window"
}
},
"internal_server_error": {
"summary": "Internal Server Error",
"description": "Example error for unexpected server-side failures",
"value": {
"code": 500,
"type": "Internal Server Error",
"correlation_id": "b129b8e0e66c41aa9541a30f67e38ce2",
"details": "An unexpected error occurred while processing your request"
}
}
}

Authorizations

X-BRONTO-API-KEY
string
header
required

Path Parameters

templateId
string<uuid>
required

The ID of the monitor template to update

Body

application/json
name
string
required

The name of the monitor template

Required string length: 1 - 255
Example:

"High Error Rate"

comparison_operator
enum<string>
required

the comparison operator of the monitor (ABOVE, ABOVE_OR_EQUAL, BELOW, BELOW_OR_EQUAL, EQUAL, NOT_EQUAL)

Available options:
BELOW,
BELOW_OR_EQUAL,
ABOVE,
ABOVE_OR_EQUAL,
EQUAL,
NOT_EQUAL
Example:

"ABOVE"

threshold
number
required

the threshold value of the monitor

Example:

1000

window
string
required

The time window to evaluate the monitor; minimum five minutes, maximum one day

Example:

"'Last 20 minutes', 'Last 2 hours', 'Last 3 days'"

metric
object
required
description
string

Extra contextual information to add to the monitor template.

Required string length: 1 - 4000
Example:

"Average response time is over 1 seconds in the last 20 minutes"

warning_threshold
number

the warning threshold value

Example:

1000

no_data_status
enum<string>

Specify the status to use in case of no data (no events matched in a time window)

Available options:
OK,
NO_DATA,
ALERT,
WARN
Example:

"OK"

group_retention
integer<int64>

Remove groups with no data after the provided time in milliseconds

Required range: 0 <= x <= 604800000
Example:

600000

aux
object

Additional monitor configuration

type
enum<string>
default:PATTERN
Available options:
PATTERN,
USAGE,
CHANGE_DETECTION
compare_to
string

For change detection monitors only. How far back in time the comparison query should be run. Minimum "5 mins ago", maximum "1 month".

Example:

"'2 hours ago', '1 days ago'"

change_type
enum<string>

For change detection monitors only. Specifies how the change values are calculated, as described in the Bronto documentation.

Available options:
DIFFERENCE,
PERCENTAGE
this_template_tags
object[]
parameters
object

Map of parameter names to their definitions. Each key represents the parameter name used within the template.

Response

Monitor template is successfully updated

id
string<uuid>
required

The unique identifier for the monitor

name
string
required

The name of the monitor

Required string length: 1 - 255
Example:

"High Error Rate"

comparison_operator
enum<string>
required

the comparison operator of the monitor (ABOVE, ABOVE_OR_EQUAL, BELOW, BELOW_OR_EQUAL, EQUAL, NOT_EQUAL)

Available options:
BELOW,
BELOW_OR_EQUAL,
ABOVE,
ABOVE_OR_EQUAL,
EQUAL,
NOT_EQUAL
Example:

"ABOVE"

threshold
string
required

the threshold value of the monitor

Example:

"1000"

window
string
required

The time window to evaluate the monitor; minimum five minutes, maximum one day

Example:

"'Last 20 minutes', 'Last 2 hours', 'Last 1 days'"

type
enum<string>
default:PATTERN
required
Available options:
PATTERN,
USAGE,
CHANGE_DETECTION
metadata
object
required

Common metadata attached to all persisted resources.

description
string

Extra contextual information to add to the monitor

Maximum string length: 4000
Example:

"Average response time is over 1 seconds in the last 20 minutes"

warning_threshold
string

the warning threshold value

Example:

"900"

actions
string

The list of actions (notifications) to take when the monitor fires or resolves

notify_once
string

Notify only the groups changing the global monitor status, i.e. notifications are sent only for the first group entering ALERT status or for the last group resolving

Example:

"false"

no_data_status
enum<string>

Specify the status to use if a group has no data (no events matched in a time window)

Available options:
OK,
NO_DATA,
ALERT,
WARN
Example:

"OK"

group_retention
integer<int64>

Remove groups with no data after the provided time in milliseconds

Required range: 0 <= x <= 604800000
Example:

600000

aux
object

Additional monitor configuration

compare_to
string

For change detection monitors only. How far back in time the comparison query should be run. Minimum "5 mins ago", maximum "1 month".

Example:

"2 hours ago"

change_type
enum<string>

For change detection monitors only. Specifies how the change values are calculated, as described in the Bronto documentation.

Available options:
DIFFERENCE,
PERCENTAGE
metric_id
object
parameters
object

Map of parameter names to their definitions. Each key represents the parameter name used within the template.